/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.48 Revision 1.134
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.48 2009/10/16 15:02:15 wired Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.134 2012/07/10 21:43:19 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator
16
17IUSE="${IUSE} debug pch"
18RDEPEND="
19 !<x11-libs/qt-assistant-${PV}
20 !>x11-libs/qt-assistant-${PV}-r9999
21 !<x11-libs/qt-core-${PV}
22 !>x11-libs/qt-core-${PV}-r9999
23 !<x11-libs/qt-dbus-${PV}
24 !>x11-libs/qt-dbus-${PV}-r9999
25 !<x11-libs/qt-demo-${PV}
26 !>x11-libs/qt-demo-${PV}-r9999
27 !<x11-libs/qt-gui-${PV}
28 !>x11-libs/qt-gui-${PV}-r9999
29 !<x11-libs/qt-opengl-${PV}
30 !>x11-libs/qt-opengl-${PV}-r9999
31 !<x11-libs/qt-phonon-${PV}
32 !>x11-libs/qt-phonon-${PV}-r9999
33 !<x11-libs/qt-qt3support-${PV}
34 !>x11-libs/qt-qt3support-${PV}-r9999
35 !<x11-libs/qt-script-${PV}
36 !>x11-libs/qt-script-${PV}-r9999
37 !<x11-libs/qt-sql-${PV}
38 !>x11-libs/qt-sql-${PV}-r9999
39 !<x11-libs/qt-svg-${PV}
40 !>x11-libs/qt-svg-${PV}-r9999
41 !<x11-libs/qt-test-${PV}
42 !>x11-libs/qt-test-${PV}-r9999
43 !<x11-libs/qt-webkit-${PV}
44 !>x11-libs/qt-webkit-${PV}-r9999
45 !<x11-libs/qt-xmlpatterns-${PV}
46 !>x11-libs/qt-xmlpatterns-${PV}-r9999
47"
48case "${PV}" in 12case ${EAPI} in
49 4.?.?_rc* | 4.?.?_beta* ) 13 2|3|4) : ;;
50 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
51 MY_PV="${PV/_/-}" 29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
52 ;; 37 ;;
53 *) 38 release)
54 SRCTYPE="${SRCTYPE:-opensource-src}" 39 if version_is_at_least 4.8.1; then
55 MY_PV="${PV}" 40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
56 ;; 44 ;;
57esac 45esac
58 46
47IUSE="aqua debug pch"
48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
59if version_is_at_least 4.5.99999999 ${PV} ; then 49if version_is_at_least 4.8; then
60 MY_P="qt-everywhere-${SRCTYPE}-${MY_PV}" 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
61else 51 version_is_at_least 4.8.3 || IUSE+=" qpa"
62 MY_P="qt-x11-${SRCTYPE}-${MY_PV}"
63fi 52fi
53
54DEPEND="virtual/pkgconfig"
55if [[ ${QT4_BUILD_TYPE} == live ]]; then
56 DEPEND+=" dev-lang/perl"
57fi
58
59RDEPEND="
60 !<x11-libs/qt-assistant-${PV}:4
61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
64 !<x11-libs/qt-core-${PV}:4
65 !>x11-libs/qt-core-${PV}-r9999:4
66 !<x11-libs/qt-dbus-${PV}:4
67 !>x11-libs/qt-dbus-${PV}-r9999:4
68 !<x11-libs/qt-declarative-${PV}:4
69 !>x11-libs/qt-declarative-${PV}-r9999:4
70 !<x11-libs/qt-demo-${PV}:4
71 !>x11-libs/qt-demo-${PV}-r9999:4
72 !<x11-libs/qt-gui-${PV}:4
73 !>x11-libs/qt-gui-${PV}-r9999:4
74 !<x11-libs/qt-multimedia-${PV}:4
75 !>x11-libs/qt-multimedia-${PV}-r9999:4
76 !<x11-libs/qt-opengl-${PV}:4
77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
80 !<x11-libs/qt-phonon-${PV}:4
81 !>x11-libs/qt-phonon-${PV}-r9999:4
82 !<x11-libs/qt-qt3support-${PV}:4
83 !>x11-libs/qt-qt3support-${PV}-r9999:4
84 !<x11-libs/qt-script-${PV}:4
85 !>x11-libs/qt-script-${PV}-r9999:4
86 !<x11-libs/qt-sql-${PV}:4
87 !>x11-libs/qt-sql-${PV}-r9999:4
88 !<x11-libs/qt-svg-${PV}:4
89 !>x11-libs/qt-svg-${PV}-r9999:4
90 !<x11-libs/qt-test-${PV}:4
91 !>x11-libs/qt-test-${PV}-r9999:4
92 !<x11-libs/qt-webkit-${PV}:4
93 !>x11-libs/qt-webkit-${PV}-r9999:4
94 !<x11-libs/qt-xmlpatterns-${PV}:4
95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
96"
97
64S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
65 99
66HOMEPAGE="http://qt.nokia.com/"
67if version_is_at_least 4.5.3 ${PV} ; then
68 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
69else
70 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.bz2"
71fi
72
73case "${PV}" in
74 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
75 *) ;;
76esac
77
78if version_is_at_least 4.5 ${PV} ; then
79 LICENSE="|| ( LGPL-2.1 GPL-3 )"
80fi
81
82# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
83# @DESCRIPTION: 101# @DESCRIPTION:
84# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
85qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
86 # EAPI=2 ebuilds set use-deps, others need this: 104 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
87 if [[ $EAPI != 2 ]]; then
88 # Make sure debug setting corresponds with qt-core (bug 258512)
89 if [[ $PN != "qt-core" ]]; then
90 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
91 ~x11-libs/qt-core-${PV} debug"
92 fi
93 105
94 # Check USE requirements 106 # Protect users by not allowing downgrades between releases.
95 qt4-build_check_use 107 # Downgrading revisions within the same release should be allowed.
108 if has_version ">${CATEGORY}/${P}-r9999:4"; then
109 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
110 eerror " *** Sanity check to keep you from breaking your system ***"
111 eerror "Downgrading Qt is completely unsupported and will break your system!"
112 die "aborting to save your system"
113 else
114 ewarn "Downgrading Qt is completely unsupported and will break your system!"
96 fi 115 fi
116 fi
97 117
98 PATH="${S}/bin:${PATH}" 118 PATH="${S}/bin${PATH:+:}${PATH}"
119 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 120 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
100 121 else
101 if ! version_is_at_least 4.1 $(gcc-version) ; then 122 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
102 ewarn "Using a GCC version lower than 4.1 is not supported!" 123 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
103 echo 124 # platform detection. Note: needs to come before any directories to
104 ebeep 3 125 # avoid extract failure.
126 [[ ${CHOST} == *-apple-darwin* ]] && \
127 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
128 ${QT4_EXTRACT_DIRECTORIES}"
105 fi 129 fi
106} 130}
131
132# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
133# @DEFAULT_UNSET
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
107 137
108# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 138# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
139# @DEFAULT_UNSET
109# @DESCRIPTION: 140# @DESCRIPTION:
110# Arguments for build_target_directories. Takes the directories, in which the 141# Arguments for build_target_directories. Takes the directories in which the
111# code should be compiled. This is a space-separated list 142# code should be compiled. This is a space-separated list.
112
113# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
114# @DESCRIPTION:
115# Space separated list including the directories that will be extracted from Qt
116# tarball
117 143
118# @FUNCTION: qt4-build_src_unpack 144# @FUNCTION: qt4-build_src_unpack
119# @DESCRIPTION: 145# @DESCRIPTION:
120# Unpacks the sources 146# Unpacks the sources.
121qt4-build_src_unpack() { 147qt4-build_src_unpack() {
122 setqtenv 148 setqtenv
123 local target targets licenses tar_pkg tar_args 149
124 if version_is_at_least 4.5 ${PV} ; then 150 if ! version_is_at_least 4.1 $(gcc-version); then
125 licenses="LICENSE.GPL3 LICENSE.LGPL" 151 ewarn "Using a GCC version lower than 4.1 is not supported."
126 else 152 fi
127 licenses="LICENSE.GPL2 LICENSE.GPL3" 153
154 if [[ ${PN} == qt-webkit ]]; then
155 eshopts_push -s extglob
156 if is-flagq '-g?(gdb)?([1-9])'; then
157 echo
158 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
159 ewarn "You may experience really long compilation times and/or increased memory usage."
160 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
161 ewarn "For more info check out https://bugs.gentoo.org/307861"
162 echo
128 fi 163 fi
129 for target in configure ${licenses} projects.pro \ 164 eshopts_pop
165 fi
166
167 case ${QT4_BUILD_TYPE} in
168 live)
169 git-2_src_unpack
170 ;;
171 release)
172 local tarball="${MY_P}.tar.gz" target= targets=
173 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
130 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 174 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
131 ${QT4_EXTRACT_DIRECTORIES}; do 175 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
176 do
132 targets="${targets} ${MY_P}/${target}" 177 targets+="${MY_P}/${target} "
133 done 178 done
134 179
135 tar_pkg=${MY_P}.tar.bz2 180 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
136 tar_args="xjpf" 181 tar -xzf "${DISTDIR}/${tarball}" ${targets}
137 if version_is_at_least 4.5.3 ${PV} ; then 182 eend $? || die "failed to unpack"
138 tar_pkg=${tar_pkg/bz2/gz}
139 tar_args="xzpf"
140 fi
141
142 echo tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
143 tar ${tar_args} "${DISTDIR}"/${tar_pkg} ${targets}
144
145 case "${PV}" in
146 4.4.?)
147 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
148 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
149 ;; 183 ;;
150 esac 184 esac
151
152 # Be backwards compatible for now
153 if [[ $EAPI != 2 ]]; then
154 qt4-build_src_prepare
155 fi
156} 185}
157 186
158# @ECLASS-VARIABLE: PATCHES 187# @ECLASS-VARIABLE: PATCHES
188# @DEFAULT_UNSET
159# @DESCRIPTION: 189# @DESCRIPTION:
160# In case you have patches to apply, specify them in PATCHES variable. Make sure 190# PATCHES array variable containing all various patches to be applied.
161# to specify the full path. This variable is necessary for src_prepare phase. 191# This variable is expected to be defined in global scope of ebuild.
162# example: 192# Make sure to specify the full path. This variable is utilised in
163# PATCHES="${FILESDIR}"/mypatch.patch 193# src_unpack/src_prepare phase, based on EAPI.
164# ${FILESDIR}"/mypatch2.patch"
165# 194#
195# @CODE
196# PATCHES=( "${FILESDIR}/mypatch.patch"
197# "${FILESDIR}/patches_folder/" )
198# @CODE
166 199
167# @FUNCTION: qt4-build_src_prepare 200# @FUNCTION: qt4-build_src_prepare
168# @DESCRIPTION: 201# @DESCRIPTION:
169# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 202# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
170# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 203# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
171qt4-build_src_prepare() { 204qt4-build_src_prepare() {
172 setqtenv 205 setqtenv
173 cd "${S}" 206
207 if [[ ${QT4_BUILD_TYPE} == live ]]; then
208 QTDIR="." ./bin/syncqt || die "syncqt failed"
209 fi
210
211 if version_is_at_least 4.7; then
212 # avoid X11 dependency in non-gui packages
213 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
214 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
215 fi
216
217 if use aqua; then
218 # provide a proper macx-g++-64
219 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
220
221 sed -e '/^CONFIG/s:app_bundle::' \
222 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
223 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
224 fi
174 225
175 if [[ ${PN} != qt-core ]]; then 226 if [[ ${PN} != qt-core ]]; then
176 skip_qmake_build_patch 227 skip_qmake_build
177 skip_project_generation_patch 228 skip_project_generation
178 symlink_binaries_to_buildtree 229 symlink_binaries_to_buildtree
179 fi 230 fi
180 231
232 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
233 # qmake bus errors with -O2 or -O3 but -O1 works
234 # Bug 373061
235 replace-flags -O[23] -O1
236 fi
237
181 # Bug 178652 238 # Bug 178652
182 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 239 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
183 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 240 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
184 append-flags -fno-gcse 241 append-flags -fno-gcse
185 fi 242 fi
186 243
244 if use_if_iuse c++0x; then
245 append-cxxflags -std=c++0x
246 fi
247
187 # Unsupported old gcc versions - hardened needs this :( 248 # Unsupported old gcc versions - hardened needs this :(
188 if [[ $(gcc-major-version) -lt "4" ]] ; then 249 if [[ $(gcc-major-version) -lt 4 ]]; then
189 ewarn "Appending -fno-stack-protector to CXXFLAGS" 250 ewarn "Appending -fno-stack-protector to CXXFLAGS"
190 append-cxxflags -fno-stack-protector 251 append-cxxflags -fno-stack-protector
191 # Bug 253127 252 # Bug 253127
192 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 253 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
193 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 254 -i mkspecs/common/g++.conf || die
255 fi
256
257 # Bug 261632
258 if use ppc64; then
259 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
260 append-flags -mminimal-toc
261 fi
262
263 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
264 sed -e "/^SYSTEM_VARIABLES=/i \
265 CC='$(tc-getCC)'\n\
266 CXX='$(tc-getCXX)'\n\
267 CFLAGS='${CFLAGS}'\n\
268 CXXFLAGS='${CXXFLAGS}'\n\
269 LDFLAGS='${LDFLAGS}'\n" \
270 -i configure \
271 || die "sed SYSTEM_VARIABLES failed"
272
273 # Respect CC, CXX, LINK and *FLAGS in config.tests
274 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
275 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
276 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
277 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
278 || die "sed config.tests failed"
279
280 if ! version_is_at_least 4.8; then
281 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
282 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
194 fi 283 fi
195 284
196 # Bug 172219 285 # Bug 172219
286 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
287
288 if [[ ${CHOST} == *-darwin* ]]; then
289 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
290 # crippled (by design) :/
291 local mac_gpp_conf=
292 if [[ -f mkspecs/common/mac-g++.conf ]]; then
293 # qt < 4.8 has mac-g++.conf
294 mac_gpp_conf="mkspecs/common/mac-g++.conf"
295 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
296 # qt >= 4.8 has g++-macx.conf
297 mac_gpp_conf="mkspecs/common/g++-macx.conf"
298 else
299 die "no known conf file for mac found"
300 fi
301 sed \
197 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 302 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
198 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 303 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
199 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 304 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
200 -e "s:X11R6/::" \ 305 -e "s:-arch\s\w*::g" \
201 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 306 -i ${mac_gpp_conf} \
307 || die "sed ${mac_gpp_conf} failed"
202 308
203 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 309 # Fix configure's -arch settings that appear in qmake/Makefile and also
204 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 310 # fix arch handling (automagically duplicates our -arch arg and breaks
205 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 311 # pch). Additionally disable Xarch support.
206 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 312 local mac_gcc_confs="${mac_gpp_conf}"
313 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
314 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
315 fi
316 sed \
317 -e "s:-arch i386::" \
318 -e "s:-arch ppc::" \
319 -e "s:-arch x86_64::" \
320 -e "s:-arch ppc64::" \
321 -e "s:-arch \$i::" \
322 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
323 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
324 -e "s:-Xarch_x86_64::g" \
325 -e "s:-Xarch_ppc64::g" \
326 -i configure ${mac_gcc_confs} \
327 || die "sed -arch/-Xarch failed"
207 328
208 base_src_prepare 329 # On Snow Leopard don't fall back to 10.5 deployment target.
330 if [[ ${CHOST} == *-apple-darwin10 ]]; then
331 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
332 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
333 -i configure ${mac_gpp_conf} \
334 || die "sed deployment target failed"
335 fi
336 fi
337
338 # this one is needed for all systems with a separate -liconv, apart from
339 # Darwin, for which the sources already cater for -liconv
340 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
341 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
342 -i config.tests/unix/iconv/iconv.pro \
343 || die "sed iconv.pro failed"
344 fi
345
346 # we need some patches for Solaris
347 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
348 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
349 # use GCC over SunStudio
350 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
351 # do not flirt with non-Prefix stuff, we're quite possessive
352 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
353 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
354
355 # apply patches
356 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
357 epatch_user
209} 358}
210 359
211# @FUNCTION: qt4-build_src_configure 360# @FUNCTION: qt4-build_src_configure
212# @DESCRIPTION: 361# @DESCRIPTION:
213# Default configure phase 362# Default configure phase
214qt4-build_src_configure() { 363qt4-build_src_configure() {
215 setqtenv 364 setqtenv
216 myconf="$(standard_configure_options) ${myconf}"
217 365
218 echo ./configure ${myconf}
219 ./configure ${myconf} || die "./configure failed"
220 myconf=""
221}
222
223# @FUNCTION: qt4-build_src_compile
224# @DESCRIPTION: Actual compile phase
225qt4-build_src_compile() {
226 setqtenv
227 # Be backwards compatible for now
228 if [[ $EAPI != 2 ]]; then
229 qt4-build_src_configure
230 fi
231
232 build_directories "${QT4_TARGET_DIRECTORIES}"
233}
234
235# @FUNCTION: qt4-build_src_install
236# @DESCRIPTION:
237# Perform the actual installation including some library fixes.
238qt4-build_src_install() {
239 setqtenv
240 install_directories "${QT4_TARGET_DIRECTORIES}"
241 install_qconfigs
242 fix_library_files
243}
244
245# @FUNCTION: setqtenv
246setqtenv() {
247 # Set up installation directories
248 QTBASEDIR=/usr/$(get_libdir)/qt4
249 QTPREFIXDIR=/usr
250 QTBINDIR=/usr/bin
251 QTLIBDIR=/usr/$(get_libdir)/qt4
252 QMAKE_LIBDIR_QT=${QTLIBDIR}
253 QTPCDIR=/usr/$(get_libdir)/pkgconfig
254 QTDATADIR=/usr/share/qt4
255 QTDOCDIR=/usr/share/doc/qt-${PV}
256 QTHEADERDIR=/usr/include/qt4
257 QTPLUGINDIR=${QTLIBDIR}/plugins
258 QTSYSCONFDIR=/etc/qt4
259 QTTRANSDIR=${QTDATADIR}/translations
260 QTEXAMPLESDIR=${QTDATADIR}/examples
261 QTDEMOSDIR=${QTDATADIR}/demos
262 QT_INSTALL_PREFIX=/usr/$(get_libdir)/qt4
263 PLATFORM=$(qt_mkspecs_dir)
264
265 unset QMAKESPEC
266}
267
268# @FUNCTION: standard_configure_options
269# @DESCRIPTION:
270# Sets up some standard configure options, like libdir (if necessary), whether
271# debug info is wanted or not.
272standard_configure_options() {
273 local myconf="" 366 local conf="
274 367 -prefix ${QTPREFIXDIR}
275 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 368 -bindir ${QTBINDIR}
276 369 -libdir ${QTLIBDIR}
277 # Disable visibility explicitly if gcc version isn't 4 370 -docdir ${QTDOCDIR}
278 if [[ "$(gcc-major-version)" -lt "4" ]]; then 371 -headerdir ${QTHEADERDIR}
279 myconf="${myconf} -no-reduce-exports" 372 -plugindir ${QTPLUGINDIR}
280 fi 373 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
281 374 -datadir ${QTDATADIR}
282 # precompiled headers doesn't work on hardened, where the flag is masked. 375 -translationdir ${QTTRANSDIR}
283 if use pch; then 376 -sysconfdir ${QTSYSCONFDIR}
284 myconf="${myconf} -pch" 377 -examplesdir ${QTEXAMPLESDIR}
285 else 378 -demosdir ${QTDEMOSDIR}
286 myconf="${myconf} -no-pch" 379 -opensource -confirm-license
287 fi 380 -shared -fast -largefile -stl -verbose
288 381 -nomake examples -nomake demos"
289 if use debug; then
290 myconf="${myconf} -debug -no-separate-debug-info"
291 else
292 myconf="${myconf} -release -no-separate-debug-info"
293 fi
294 382
295 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 383 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
296 # $(tc-arch). Therefore we convert it to supported values. 384 # $(tc-arch). Therefore we convert it to supported values.
297 case "$(tc-arch)" in 385 case "$(tc-arch)" in
298 amd64) myconf="${myconf} -arch x86_64" ;; 386 amd64|x64-*) conf+=" -arch x86_64" ;;
387 ppc-macos) conf+=" -arch ppc" ;;
299 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 388 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
389 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
390 x86-macos) conf+=" -arch x86" ;;
300 x86|x86-*) myconf="${myconf} -arch i386" ;; 391 x86|x86-*) conf+=" -arch i386" ;;
301 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 392 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
302 hppa|sh) myconf="${myconf} -arch generic" ;; 393 hppa|sh) conf+=" -arch generic" ;;
303 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 394 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
304 esac 395 esac
305 396
306 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build 397 conf+=" -platform $(qt_mkspecs_dir)"
307 local exceptions= 398
308 case "${PV}" in 399 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
309 4.6.*) 400
310 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then 401 # debug/release
311 exceptions="-no-exceptions" 402 if use debug; then
403 conf+=" -debug"
404 else
405 conf+=" -release"
406 fi
407 conf+=" -no-separate-debug-info"
408
409 # exceptions USE flag
410 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
411
412 # disable rpath on Qt >= 4.8 (bug 380415)
413 # but leave it enabled on prefix (bug 417169)
414 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
415
416 # precompiled headers don't work on hardened, where the flag is masked
417 conf+=" $(qt_use pch)"
418
419 # -reduce-relocations
420 # This flag seems to introduce major breakage to applications,
421 # mostly to be seen as a core dump with the message "QPixmap: Must
422 # construct a QApplication before a QPaintDevice" on Solaris.
423 # -- Daniel Vergien
424 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
425
426 # this one is needed for all systems with a separate -liconv, apart from
427 # Darwin, for which the sources already cater for -liconv
428 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
429 conf+=" -liconv"
430 fi
431
432 if use_if_iuse glib; then
433 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
434 # avoid the -pthread argument
435 conf+=" ${glibflags//-pthread}"
436 unset glibflags
437 fi
438
439 if use_if_iuse qpa; then
440 echo
441 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
442 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
443 ewarn "disable it before reporting any bugs related to this useflag."
444 echo
445 conf+=" -qpa"
446 fi
447
448 if use aqua; then
449 # On (snow) leopard use the new (frameworked) cocoa code.
450 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
451 conf+=" -cocoa -framework"
452 # We need the source's headers, not the installed ones.
453 conf+=" -I${S}/include"
454 # Add hint for the framework location.
455 conf+=" -F${QTLIBDIR}"
456
457 # We are crazy and build cocoa + qt3support :-)
458 if use qt3support; then
459 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
460 -i configure || die
312 fi 461 fi
313 ;; 462 else
314 *) 463 conf+=" -no-framework"
315 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions" 464 fi
316 ;; 465 else
317 esac 466 # freetype2 include dir is non-standard, thus pass it to configure
467 conf+=" $(pkg-config --cflags-only-I freetype2)"
468 fi
318 469
319 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath
320 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
321 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
322 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
323 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
324 -demosdir ${QTDEMOSDIR} -silent -fast
325 ${exceptions}
326 -reduce-relocations -nomake examples -nomake demos"
327
328 # Make eclass >= 4.5.x ready
329 case "${MY_PV}" in
330 4.5.* | 4.6.* )
331 myconf="${myconf} -opensource"
332 ;;
333 esac
334
335 echo "${myconf}" 470 conf+=" ${myconf}"
471 myconf=
472
473 echo ./configure ${conf}
474 ./configure ${conf} || die "./configure failed"
475
476 prepare_directories ${QT4_TARGET_DIRECTORIES}
336} 477}
478
479# @FUNCTION: qt4-build_src_compile
480# @DESCRIPTION:
481# Actual compile phase
482qt4-build_src_compile() {
483 setqtenv
484
485 build_directories ${QT4_TARGET_DIRECTORIES}
486}
487
488# @FUNCTION: qt4-build_src_test
489# @DESCRIPTION:
490# Runs tests only in target directories.
491qt4-build_src_test() {
492 # QtMultimedia does not have any test suite (bug #332299)
493 [[ ${PN} == qt-multimedia ]] && return
494
495 for dir in ${QT4_TARGET_DIRECTORIES}; do
496 emake -j1 check -C ${dir}
497 done
498}
499
500# @FUNCTION: fix_includes
501# @DESCRIPTION:
502# For MacOS X we need to add some symlinks when frameworks are
503# being used, to avoid complications with some more or less stupid packages.
504fix_includes() {
505 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
506 local frw dest f h rdir
507 # Some packages tend to include <Qt/...>
508 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
509
510 # Fake normal headers when frameworks are installed... eases life later
511 # on, make sure we use relative links though, as some ebuilds assume
512 # these dirs exist in src_install to add additional files
513 f=${QTHEADERDIR}
514 h=${QTLIBDIR}
515 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
516 f=${f#*/}
517 h=${h#*/}
518 done
519 rdir=${h}
520 f="../"
521 while [[ ${h} == */* ]] ; do
522 f="${f}../"
523 h=${h#*/}
524 done
525 rdir="${f}${rdir}"
526
527 for frw in "${D}${QTLIBDIR}"/*.framework; do
528 [[ -e "${frw}"/Headers ]] || continue
529 f=$(basename ${frw})
530 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
531 dosym "${rdir}"/${f}/Headers "${dest}"
532
533 # Link normal headers as well.
534 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
535 h=$(basename ${hdr})
536 dosym "../${rdir}"/${f}/Headers/${h} \
537 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
538 done
539 done
540 fi
541}
542
543# @FUNCTION: qt4-build_src_install
544# @DESCRIPTION:
545# Perform the actual installation including some library fixes.
546qt4-build_src_install() {
547 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
548 setqtenv
549
550 install_directories ${QT4_TARGET_DIRECTORIES}
551 install_qconfigs
552 fix_library_files
553 fix_includes
554
555 # remove .la files since we are building only shared Qt libraries
556 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
557}
558
559# @FUNCTION: setqtenv
560# @INTERNAL
561setqtenv() {
562 # Set up installation directories
563 QTPREFIXDIR=${EPREFIX}/usr
564 QTBINDIR=${EPREFIX}/usr/bin
565 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
566 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
567 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
568 QTHEADERDIR=${EPREFIX}/usr/include/qt4
569 QTPLUGINDIR=${QTLIBDIR}/plugins
570 QTIMPORTDIR=${QTLIBDIR}/imports
571 QTDATADIR=${EPREFIX}/usr/share/qt4
572 QTTRANSDIR=${QTDATADIR}/translations
573 QTSYSCONFDIR=${EPREFIX}/etc/qt4
574 QTEXAMPLESDIR=${QTDATADIR}/examples
575 QTDEMOSDIR=${QTDATADIR}/demos
576 QMAKE_LIBDIR_QT=${QTLIBDIR}
577 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
578
579 PLATFORM=$(qt_mkspecs_dir)
580 unset QMAKESPEC
581
582 export XDG_CONFIG_HOME="${T}"
583}
584
585# @FUNCTION: prepare_directories
586# @USAGE: < directories >
587# @INTERNAL
588# @DESCRIPTION:
589# Generates Makefiles for the given list of directories.
590prepare_directories() {
591 for x in "$@"; do
592 pushd "${S}"/${x} >/dev/null || die
593 einfo "Running qmake in: ${x}"
594 # avoid running over the maximum argument number, bug #299810
595 {
596 echo "${S}"/mkspecs/common/*.conf
597 find "${S}" -name '*.pr[io]'
598 } | xargs sed -i \
599 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
600 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
601 || die
602 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
603 popd >/dev/null || die
604 done
605}
606
337 607
338# @FUNCTION: build_directories 608# @FUNCTION: build_directories
339# @USAGE: < directories > 609# @USAGE: < directories >
610# @INTERNAL
340# @DESCRIPTION: 611# @DESCRIPTION:
341# Compiles the code in $QT4_TARGET_DIRECTORIES 612# Compiles the code in the given list of directories.
342build_directories() { 613build_directories() {
343 local dirs="$@"
344 for x in ${dirs}; do 614 for x in "$@"; do
345 cd "${S}"/${x} 615 pushd "${S}"/${x} >/dev/null || die
346 sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:/usr/$(get_libdir)/qt4:g" $(find "${S}" -name '*.pr[io]') "${S}"/mkspecs/common/linux.conf || die 616 emake CC="$(tc-getCC)" \
347 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 617 CXX="$(tc-getCXX)" \
348 emake CC="@echo compiling \$< && $(tc-getCC)" \
349 CXX="@echo compiling \$< && $(tc-getCXX)" \
350 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed" 618 LINK="$(tc-getCXX)" || die "emake failed"
619 popd >/dev/null || die
351 done 620 done
352} 621}
353 622
354# @FUNCTION: install_directories 623# @FUNCTION: install_directories
355# @USAGE: < directories > 624# @USAGE: < directories >
625# @INTERNAL
356# @DESCRIPTION: 626# @DESCRIPTION:
357# run emake install in the given directories, which are separated by spaces 627# Runs emake install in the given directories, which are separated by spaces.
358install_directories() { 628install_directories() {
359 local dirs="$@"
360 for x in ${dirs}; do 629 for x in "$@"; do
361 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 630 pushd "${S}"/${x} >/dev/null || die
362 emake INSTALL_ROOT="${D}" install || die "emake install failed" 631 emake INSTALL_ROOT="${D}" install || die "emake install failed"
363 popd >/dev/null || die "Can't popd from ${S}/${x}" 632 popd >/dev/null || die
364 done 633 done
365} 634}
366 635
367# @ECLASS-VARIABLE: QCONFIG_ADD 636# @ECLASS-VARIABLE: QCONFIG_ADD
368# @DESCRIPTION: 637# @DESCRIPTION:
369# List options that need to be added to QT_CONFIG in qconfig.pri 638# List options that need to be added to QT_CONFIG in qconfig.pri
370QCONFIG_ADD="${QCONFIG_ADD:-}" 639: ${QCONFIG_ADD:=}
371 640
372# @ECLASS-VARIABLE: QCONFIG_REMOVE 641# @ECLASS-VARIABLE: QCONFIG_REMOVE
373# @DESCRIPTION: 642# @DESCRIPTION:
374# List options that need to be removed from QT_CONFIG in qconfig.pri 643# List options that need to be removed from QT_CONFIG in qconfig.pri
375QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 644: ${QCONFIG_REMOVE:=}
376 645
377# @ECLASS-VARIABLE: QCONFIG_DEFINE 646# @ECLASS-VARIABLE: QCONFIG_DEFINE
378# @DESCRIPTION: 647# @DESCRIPTION:
379# List variables that should be defined at the top of QtCore/qconfig.h 648# List variables that should be defined at the top of QtCore/qconfig.h
380QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 649: ${QCONFIG_DEFINE:=}
381 650
382# @FUNCTION: install_qconfigs 651# @FUNCTION: install_qconfigs
652# @INTERNAL
653# @DESCRIPTION:
383# @DESCRIPTION: Install gentoo-specific mkspecs configurations 654# Install gentoo-specific mkspecs configurations.
384install_qconfigs() { 655install_qconfigs() {
385 local x 656 local x
386 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 657 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
387 for x in QCONFIG_ADD QCONFIG_REMOVE; do 658 for x in QCONFIG_ADD QCONFIG_REMOVE; do
388 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 659 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
389 done 660 done
390 insinto ${QTDATADIR}/mkspecs/gentoo 661 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
391 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 662 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
392 fi 663 fi
393 664
394 if [[ -n ${QCONFIG_DEFINE} ]]; then 665 if [[ -n ${QCONFIG_DEFINE} ]]; then
395 for x in ${QCONFIG_DEFINE}; do 666 for x in ${QCONFIG_DEFINE}; do
396 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 667 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
397 done 668 done
398 insinto ${QTHEADERDIR}/Gentoo 669 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
399 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 670 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
400 fi 671 fi
401} 672}
402 673
403# @FUNCTION: generate_qconfigs 674# @FUNCTION: generate_qconfigs
404# @DESCRIPTION: Generates gentoo-specific configurations 675# @INTERNAL
676# @DESCRIPTION:
677# Generates gentoo-specific qconfig.{h,pri}.
405generate_qconfigs() { 678generate_qconfigs() {
406 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 679 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
407 local x qconfig_add qconfig_remove qconfig_new 680 local x qconfig_add qconfig_remove qconfig_new
408 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 681 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
409 [[ -f ${x} ]] || continue 682 [[ -f ${x} ]] || continue
410 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 683 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
411 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 684 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
412 done 685 done
413 686
414 # these error checks do not use die because dying in pkg_post{inst,rm} 687 # these error checks do not use die because dying in pkg_post{inst,rm}
415 # just makes things worse. 688 # just makes things worse.
416 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 689 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
423 696
424 # generate list of QT_CONFIG entries from the existing list 697 # generate list of QT_CONFIG entries from the existing list
425 # including qconfig_add and excluding qconfig_remove 698 # including qconfig_add and excluding qconfig_remove
426 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 699 for x in $(sed -n 's/^QT_CONFIG +=//p' \
427 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 700 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
428 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 701 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
429 done 702 done
430 703
431 # replace the existing QT_CONFIG list with qconfig_new 704 # replace the existing QT_CONFIG list with qconfig_new
432 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 705 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
433 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 706 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
457 fi 730 fi
458 fi 731 fi
459} 732}
460 733
461# @FUNCTION: qt4-build_pkg_postrm 734# @FUNCTION: qt4-build_pkg_postrm
735# @DESCRIPTION:
462# @DESCRIPTION: Generate configurations when the package is completely removed 736# Regenerate configuration when the package is completely removed.
463qt4-build_pkg_postrm() { 737qt4-build_pkg_postrm() {
464 generate_qconfigs 738 generate_qconfigs
465} 739}
466 740
467# @FUNCTION: qt4-build_pkg_postinst 741# @FUNCTION: qt4-build_pkg_postinst
742# @DESCRIPTION:
468# @DESCRIPTION: Generate configuration, plus throws a message about possible 743# Regenerate configuration, plus throw a message about possible
469# breakages and proposed solutions. 744# breakages and proposed solutions.
470qt4-build_pkg_postinst() { 745qt4-build_pkg_postinst() {
471 generate_qconfigs 746 generate_qconfigs
472 echo
473 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
474 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
475 ewarn "should recompile the packages providing these plugins. Also, make sure you"
476 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
477 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
478 ewarn
479 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
480 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
481 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
482 ewarn "configuration."
483 ewarn
484 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
485 echo
486} 747}
487 748
488# @FUNCTION: skip_qmake_build_patch 749# @FUNCTION: skip_qmake_build
750# @INTERNAL
489# @DESCRIPTION: 751# @DESCRIPTION:
490# Don't need to build qmake, as it's already installed from qt-core 752# Patches configure to skip qmake compilation, as it's already installed by qt-core.
491skip_qmake_build_patch() { 753skip_qmake_build() {
492 # Don't need to build qmake, as it's already installed from qt-core
493 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 754 sed -i -e "s:if true:if false:g" "${S}"/configure || die
494} 755}
495 756
496# @FUNCTION: skip_project_generation_patch 757# @FUNCTION: skip_project_generation
758# @INTERNAL
497# @DESCRIPTION: 759# @DESCRIPTION:
498# Exit the script early by throwing in an exit before all of the .pro files are scanned 760# Exit the script early by throwing in an exit before all of the .pro files are scanned.
499skip_project_generation_patch() { 761skip_project_generation() {
500 # Exit the script early by throwing in an exit before all of the .pro files are scanned
501 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 762 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
502 -i "${S}"/configure || die "Sed failed"
503} 763}
504 764
505# @FUNCTION: symlink_binaries_to_buildtree 765# @FUNCTION: symlink_binaries_to_buildtree
766# @INTERNAL
506# @DESCRIPTION: 767# @DESCRIPTION:
507# Symlink generated binaries to buildtree so they can be used during compilation 768# Symlinks generated binaries to buildtree, so they can be used during compilation time.
508# time
509symlink_binaries_to_buildtree() { 769symlink_binaries_to_buildtree() {
510 for bin in qmake moc uic rcc; do 770 for bin in qmake moc uic rcc; do
511 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 771 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
512 done 772 done
513} 773}
514 774
515# @FUNCTION: fix_library_files 775# @FUNCTION: fix_library_files
776# @INTERNAL
516# @DESCRIPTION: 777# @DESCRIPTION:
517# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 778# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
518# moves the *.pc-files into the pkgconfig directory 779# moves the *.pc files into the pkgconfig directory.
519fix_library_files() { 780fix_library_files() {
781 local libfile
520 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 782 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
521 if [[ -e ${libfile} ]]; then 783 if [[ -e ${libfile} ]]; then
522 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 784 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
523 fi 785 fi
524 done 786 done
525 787
526 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 788 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
527 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 789 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
528 if [[ -e ${libfile} ]]; then 790 if [[ -e ${libfile} ]]; then
529 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 791 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
530 792
531 # Move .pc files into the pkgconfig directory 793 # Move .pc files into the pkgconfig directory
532 dodir ${QTPCDIR} 794 dodir ${QTPCDIR#${EPREFIX}}
533 mv ${libfile} "${D}"/${QTPCDIR}/ \ 795 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
534 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
535 fi 796 fi
536 done 797 done
537 798
538 # Don't install an empty directory 799 # Don't install an empty directory
539 rmdir "${D}"/${QTLIBDIR}/pkgconfig 800 rmdir "${D}"/${QTLIBDIR}/pkgconfig
540} 801}
541 802
542# @FUNCTION: qt_use 803# @FUNCTION: qt_use
543# @USAGE: < flag > [ feature ] [ enableval ] 804# @USAGE: < flag > [ feature ] [ enableval ]
544# @DESCRIPTION: 805# @DESCRIPTION:
545# This will echo "${enableval}-${feature}" if <flag> is enabled, or 806# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
546# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 807# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
547# will be used for that. If [enableval] is not specified, it omits the 808# will be used for that. If [enableval] is not specified, it omits the
548# assignment-part 809# "-${enableval}" part.
549qt_use() { 810qt_use() {
550 local flag="${1}" 811 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
551 local feature="${1}"
552 local enableval=
553
554 [[ -n ${2} ]] && feature=${2}
555 [[ -n ${3} ]] && enableval="-${3}"
556
557 if use ${flag}; then
558 echo "${enableval}-${feature}"
559 else
560 echo "-no-${feature}"
561 fi
562}
563
564# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
565# @DESCRIPTION:
566# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
567# (eutils.eclass), line per line.
568#
569# Example:
570# @CODE
571# pkg_setup() {
572# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
573# ~x11-libs/qt-gui-${PV} qt3support"
574# qt4-build_check_use
575# }
576# @CODE
577
578# Run built_with_use on each flag and print appropriate error messages if any
579# flags are missing
580
581_qt_built_with_use() {
582 local missing opt pkg flag flags
583
584 if [[ ${1} = "--missing" ]]; then
585 missing="${1} ${2}" && shift 2
586 fi
587 if [[ ${1:0:1} = "-" ]]; then
588 opt=${1} && shift
589 fi
590
591 pkg=${1} && shift
592
593 for flag in "${@}"; do
594 flags="${flags} ${flag}"
595 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
596 flags="${flags}*"
597 else
598 [[ ${opt} = "-o" ]] && return 0
599 fi
600 done
601 if [[ "${flags# }" = "${@}" ]]; then
602 return 0
603 fi
604 if [[ ${opt} = "-o" ]]; then
605 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
606 else
607 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
608 fi
609 return 1
610}
611
612# @FUNCTION: qt4-build_check_use
613# @DESCRIPTION:
614# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
615# USE flags listed.
616#
617# If any of the required USE flags are missing, an eerror will be printed for
618# each package with missing USE flags.
619qt4-build_check_use() {
620 local line missing
621 while read line; do
622 [[ -z ${line} ]] && continue
623 if ! _qt_built_with_use ${line}; then
624 missing=true
625 fi
626 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
627 if [[ -n ${missing} ]]; then
628 echo
629 eerror "Flags marked with an * are missing."
630 die "Missing USE flags found"
631 fi
632} 812}
633 813
634# @FUNCTION: qt_mkspecs_dir 814# @FUNCTION: qt_mkspecs_dir
635# @RETURN: the specs-directory w/o path 815# @RETURN: the specs-directory w/o path
636# @DESCRIPTION: 816# @DESCRIPTION:
637# Allows us to define which mkspecs dir we want to use. 817# Allows us to define which mkspecs dir we want to use.
638qt_mkspecs_dir() { 818qt_mkspecs_dir() {
639 # Allows us to define which mkspecs dir we want to use.
640 local spec 819 local spec=
641 820
642 case ${CHOST} in 821 case "${CHOST}" in
643 *-freebsd*|*-dragonfly*) 822 *-freebsd*|*-dragonfly*)
644 spec="freebsd" ;; 823 spec=freebsd ;;
645 *-openbsd*) 824 *-openbsd*)
646 spec="openbsd" ;; 825 spec=openbsd ;;
647 *-netbsd*) 826 *-netbsd*)
648 spec="netbsd" ;; 827 spec=netbsd ;;
649 *-darwin*) 828 *-darwin*)
829 if use aqua; then
830 # mac with carbon/cocoa
831 spec=macx
832 else
833 # darwin/mac with x11
650 spec="darwin" ;; 834 spec=darwin
835 fi
836 ;;
837 *-solaris*)
838 spec=solaris ;;
651 *-linux-*|*-linux) 839 *-linux-*|*-linux)
652 spec="linux" ;; 840 spec=linux ;;
653 *) 841 *)
654 die "Unknown CHOST, no platform choosen." 842 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
655 esac 843 esac
656 844
657 CXX=$(tc-getCXX) 845 case "$(tc-getCXX)" in
658 if [[ ${CXX/g++/} != ${CXX} ]]; then 846 *g++*)
659 spec="${spec}-g++" 847 spec+=-g++ ;;
660 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 848 *icpc*)
661 spec="${spec}-icc" 849 spec+=-icc ;;
662 else 850 *)
663 die "Unknown compiler ${CXX}." 851 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
664 fi 852 esac
665 if [[ -n "${LIBDIR/lib}" ]]; then 853
666 spec="${spec}-${LIBDIR/lib}" 854 # Add -64 for 64bit profiles
855 if use x64-freebsd ||
856 use amd64-linux ||
857 use x64-macos ||
858 use x64-solaris ||
859 use sparc64-solaris
860 then
861 spec+=-64
667 fi 862 fi
668 863
669 echo "${spec}" 864 echo "${spec}"
670} 865}
671 866
672case ${EAPI:-0} in 867# @FUNCTION: qt_nolibx11
673 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 868# @INTERNAL
869# @DESCRIPTION:
870# Ignore X11 tests for packages that don't need X libraries installed.
871qt_nolibx11() {
872 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
873 die "x11 check sed failed"
874}
875
674 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 876EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
675esac

Legend:
Removed from v.1.48  
changed lines
  Added in v.1.134

  ViewVC Help
Powered by ViewVC 1.1.20